/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.buff.Module
 *  mkdb.Procedure
 *  xbean.Pod
 *  xbean.PvP5QueueRole
 */
package fire.pb.battle.pvp5;

import fire.pb.battle.pvp5.PvP5CampCountdown;
import fire.pb.battle.pvp5.PvP5Control;
import fire.pb.battle.pvp5.PvP5Judge;
import fire.pb.battle.pvp5.PvP5RaceProxy;
import fire.pb.battle.pvp5.PvP5RoleProxy;
import fire.pb.battle.pvp5.PvP5RoleStateManager;
import fire.pb.battle.pvp5.SPvP5ReadyFight;
import fire.pb.buff.Module;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.function.Function;
import mkdb.Procedure;
import xbean.Pod;
import xbean.PvP5QueueRole;

public class PPvP5Scan
extends Procedure {
    private final int grade;

    public PPvP5Scan(int grade) {
        this.grade = grade;
    }

    protected boolean process() {
        final PvP5RaceProxy race = PvP5RaceProxy.getPvP5RaceProxy(this.grade);
        if (race.getXRace() == null) {
            return false;
        }
        if (!race.isOpening()) {
            return false;
        }
        final PvP5Judge judge = new PvP5Judge(race);
        final PvP5Judge.EResult result = judge.predict();
        if (result != PvP5Judge.EResult.NULL) {
            final int camp = result == PvP5Judge.EResult.AWIN ? 0 : 1;
            PvP5CampCountdown.getInstance().enter(this.grade, camp);
            int retRemainMinute = PvP5CampCountdown.getInstance().tick(this.grade, new Function<Integer, Void>(){

                @Override
                public Void apply(Integer remainMinute) {
                    if (remainMinute > 0) {
                        PvP5CampCountdown.broadcast(PPvP5Scan.this.grade, camp, remainMinute);
                    } else {
                        judge.award(result);
                        race.end();
                    }
                    return null;
                }
            });
            if (retRemainMinute == 0) {
                return true;
            }
        } else {
            PvP5CampCountdown.getInstance().leave(this.grade);
        }
        LinkedList<Long> roleIds = new LinkedList<Long>();
        PPvP5Scan.scan(roleIds, race.getXRace().getAllrolesidcampa());
        PPvP5Scan.scan(roleIds, race.getXRace().getAllrolesidcampb());
        HashSet<Long> existRoleIds = new HashSet<Long>();
        for (PvP5QueueRole queueRole : race.getXRace().getWaitingqueue()) {
            existRoleIds.add(queueRole.getRoleid());
        }
        long now = System.currentTimeMillis();
        for (Long roleId : roleIds) {
            if (existRoleIds.contains(roleId) || !PPvP5Scan.isCanEnterWait(race, roleId, now)) continue;
            PvP5QueueRole newQueueRole = Pod.newPvP5QueueRole();
            newQueueRole.setRoleid(roleId.longValue());
            newQueueRole.setEnterqueuetime(now);
            race.getXRace().getWaitingqueue().add(newQueueRole);
            PvP5RoleProxy.notifyTeamProtocol(roleId, new SPvP5ReadyFight());
            if (!PvP5Control.getLogger().isDebugEnabled()) continue;
            PvP5Control.getLogger().debug((Object)("PVP5::[PPvP5Scan]  grade:" + this.grade + " roleId:" + roleId));
        }
        return true;
    }

    private static void scan(List<Long> outRoleIds, List<Long> inRoleIds) {
        for (long roleId : inRoleIds) {
            if (Module.existState((long)roleId, (int)507008) || Module.existState((long)roleId, (int)507004) || Module.existState((long)roleId, (int)507005) || Module.existState((long)roleId, (int)507027)) continue;
            outRoleIds.add(roleId);
        }
    }

    private static boolean isCanEnterWait(PvP5RaceProxy race, long roleId, long now) {
        if (!PvP5RoleStateManager.getInstance().checkPvPState(roleId, 0)) {
            return false;
        }
        return race.roleIsCanReady(roleId, true);
    }
}

